﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;

namespace InstBoy
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private void SendTone(int note)
        {
            if (cmbPortName.Items.Count == 0) return;
            byte[] buffer = new byte[10 * 7] { 0x10, 0x00, 0x12, 0xF5, 0x13, 0x16, 0x14, 0x84, 0x11, 0x80,
                                             0x10, 0x00, 0x12, 0xF5, 0x13, 0x83, 0x14, 0x84, 0x11, 0x80,
                                             0x10, 0x00, 0x12, 0xF5, 0x13, 0xe5, 0x14, 0x84, 0x11, 0x80,
                                             0x10, 0x00, 0x12, 0xF5, 0x13, 0x11, 0x14, 0x85, 0x11, 0x80,
                                             0x10, 0x00, 0x12, 0xF5, 0x13, 0x63, 0x14, 0x85, 0x11, 0x80,
                                             0x10, 0x00, 0x12, 0xF5, 0x13, 0xac, 0x14, 0x85, 0x11, 0x80,
                                             0x10, 0x00, 0x12, 0xF5, 0x13, 0xed, 0x14, 0x85, 0x11, 0x80
            };

            string PortName = cmbPortName.SelectedItem.ToString();// "COM3";
            int BaudRate = 9600;
            Parity Parity = Parity.None;
            int DataBits = 8;
            StopBits StopBits = StopBits.One;

            SerialPort myPort = new SerialPort(PortName, BaudRate, Parity, DataBits, StopBits);
            myPort.DtrEnable = false;
            myPort.RtsEnable = false;
            
            myPort.Open();
            myPort.DiscardOutBuffer();
            myPort.Write(buffer, note * 10, 10);
            while (myPort.BytesToWrite > 0) { Application.DoEvents(); }
            myPort.Close();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            //! 利用可能なシリアルポート名の配列を取得する.
            string[] PortList = SerialPort.GetPortNames();

            cmbPortName.Items.Clear();

            //! シリアルポート名をコンボボックスにセットする.
            foreach (string PortName in PortList)
            {
                cmbPortName.Items.Add(PortName);
            }
            if (cmbPortName.Items.Count > 0)
            {
                cmbPortName.SelectedIndex = 0;
            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            SendTone(0);
        }
        private void button2_Click(object sender, EventArgs e)
        {
            SendTone(1);
        }
        private void button3_Click(object sender, EventArgs e)
        {
            SendTone(2);
        }
        private void button4_Click(object sender, EventArgs e)
        {
            SendTone(3);
        }
        private void button5_Click(object sender, EventArgs e)
        {
            SendTone(4);
        }
        private void button6_Click(object sender, EventArgs e)
        {
            SendTone(5);
        }
        private void button7_Click(object sender, EventArgs e)
        {
            SendTone(6);
        }
    }
}
